Index: less/Makefile.aut
diff -u less/Makefile.aut:1.1.1.2 less/Makefile.aut:1.3
--- less/Makefile.aut:1.1.1.2	Sun Dec  1 05:41:04 1996
+++ less/Makefile.aut	Sun Dec  1 05:55:40 1996
@@ -12,7 +12,7 @@
 	help.c ifile.c input.c jump.c line.c linenum.c \
 	lsystem.c mark.c optfunc.c option.c opttbl.c os.c \
 	output.c position.c prompt.c search.c signal.c \
-	tags.c ttyin.c version.c  
+	tags.c ttyin.c version.c multi.c  
 DISTFILES_W = \
 	defines.ds  Makefile.dsb Makefile.dsg Makefile.dsm \
 	defines.o2  Makefile.o2e \
Index: less/Makefile.dsb
diff -u less/Makefile.dsb:1.1.1.1 less/Makefile.dsb:1.2
--- less/Makefile.dsb:1.1.1.1	Sun Dec  1 05:41:23 1996
+++ less/Makefile.dsb	Sun Dec  1 06:03:45 1996
@@ -23,7 +23,7 @@
 	input.obj jump.obj line.obj linenum.obj lsystem.obj \
 	mark.obj optfunc.obj option.obj opttbl.obj os.obj output.obj \
 	position.obj prompt.obj search.obj signal.obj tags.obj \
-	ttyin.obj version.obj
+	ttyin.obj version.obj multi.obj
 
 all: less$(EXT) lesskey$(EXT)
 
Index: less/Makefile.dsg
diff -u less/Makefile.dsg:1.1.1.1 less/Makefile.dsg:1.2
--- less/Makefile.dsg:1.1.1.1	Sun Dec  1 05:41:23 1996
+++ less/Makefile.dsg	Sun Dec  1 06:03:45 1996
@@ -26,7 +26,7 @@
 	help.${O} ifile.${O} input.${O} jump.${O} line.${O} linenum.${O} \
 	lsystem.${O} mark.${O} optfunc.${O} option.${O} opttbl.${O} os.${O} \
 	output.${O} position.${O} prompt.${O} search.${O} signal.${O} \
-	tags.${O} ttyin.${O} version.${O}
+	tags.${O} ttyin.${O} version.${O} multi.${O}
 
 all: less lesskey
 
Index: less/Makefile.dsm
diff -u less/Makefile.dsm:1.1.1.1 less/Makefile.dsm:1.2
--- less/Makefile.dsm:1.1.1.1	Sun Dec  1 05:41:23 1996
+++ less/Makefile.dsm	Sun Dec  1 06:03:46 1996
@@ -32,7 +32,7 @@
 	input.obj jump.obj line.obj linenum.obj lsystem.obj \
 	mark.obj optfunc.obj option.obj opttbl.obj os.obj output.obj \
 	position.obj prompt.obj search.obj signal.obj tags.obj \
-	ttyin.obj version.obj
+	ttyin.obj version.obj multi.obj
 
 all: less lesskey
 
Index: less/Makefile.o2e
diff -u less/Makefile.o2e:1.1.1.1 less/Makefile.o2e:1.2
--- less/Makefile.o2e:1.1.1.1	Sun Dec  1 05:41:23 1996
+++ less/Makefile.o2e	Sun Dec  1 06:03:46 1996
@@ -23,7 +23,7 @@
 	help.${O} ifile.${O} input.${O} jump.${O} line.${O} linenum.${O} \
 	lsystem.${O} mark.${O} optfunc.${O} option.${O} opttbl.${O} os.${O} \
 	output.${O} position.${O} prompt.${O} search.${O} signal.${O} \
-	tags.${O} ttyin.${O} version.${O}  regexp.${O}
+	tags.${O} ttyin.${O} version.${O}  regexp.${O} multi.${O}
 
 all:    less.exe lesskey.exe
 
Index: less/Makefile.o9c
diff -u less/Makefile.o9c:1.1.1.2 less/Makefile.o9c:1.3
--- less/Makefile.o9c:1.1.1.2	Sun Dec  1 05:41:24 1996
+++ less/Makefile.o9c	Sun Dec  1 05:55:41 1996
@@ -27,7 +27,7 @@
 	help.${O} ifile.${O} input.${O} jump.${O} line.${O} linenum.${O} \
 	lsystem.${O} mark.${O} optfunc.${O} option.${O} opttbl.${O} os.${O} \
 	output.${O} position.${O} prompt.${O} search.${O} signal.${O} \
-	tags.${O} ttyin.${O} version.${O}  regexp.${O}
+	tags.${O} ttyin.${O} version.${O}  regexp.${O} multi.${O}
 
 all: less lessecho lesskey
 
Index: less/Makefile.o9u
diff -u less/Makefile.o9u:1.1.1.1 less/Makefile.o9u:1.2
--- less/Makefile.o9u:1.1.1.1	Sat Sep 14 00:36:40 1996
+++ less/Makefile.o9u	Sat Sep 14 01:00:23 1996
@@ -26,7 +26,7 @@
 	help.${O} ifile.${O} input.${O} jump.${O} line.${O} linenum.${O} \
 	lsystem.${O} mark.${O} optfunc.${O} option.${O} opttbl.${O} os.${O} \
 	output.${O} position.${O} prompt.${O} search.${O} signal.${O} \
-	tags.${O} ttyin.${O} version.${O}  regexp.${O}
+	tags.${O} ttyin.${O} version.${O}  regexp.${O} multi.${O}
 
 all: less lesskey
 
Index: less/Makefile.wnb
diff -u less/Makefile.wnb:1.1.1.1 less/Makefile.wnb:1.2
--- less/Makefile.wnb:1.1.1.1	Sun Dec  1 05:41:25 1996
+++ less/Makefile.wnb	Sun Dec  1 06:03:48 1996
@@ -23,7 +23,7 @@
 	input.obj jump.obj line.obj linenum.obj lsystem.obj \
 	mark.obj optfunc.obj option.obj opttbl.obj os.obj output.obj \
 	position.obj prompt.obj search.obj signal.obj tags.obj \
-	ttyin.obj version.obj regexp.obj
+	ttyin.obj version.obj regexp.obj multi.obj
 
 all: less lesskey
 
Index: less/Makefile.wnm
diff -u less/Makefile.wnm:1.1.1.1 less/Makefile.wnm:1.2
--- less/Makefile.wnm:1.1.1.1	Sun Dec  1 05:41:25 1996
+++ less/Makefile.wnm	Sun Dec  1 06:03:48 1996
@@ -22,7 +22,7 @@
 	input.obj jump.obj line.obj linenum.obj lsystem.obj \
 	mark.obj optfunc.obj option.obj opttbl.obj os.obj output.obj \
 	position.obj prompt.obj search.obj signal.obj tags.obj \
-	ttyin.obj version.obj regexp.obj
+	ttyin.obj version.obj regexp.obj multi.obj
 
 all: less.exe lesskey.exe
 
Index: less/README.iso
diff -u /dev/null less/README.iso:1.9
--- /dev/null	Sun Mar  9 23:07:13 1997
+++ less/README.iso	Sat Jan 25 07:12:41 1997
@@ -0,0 +1,173 @@
+=========================================================================
+    This is the distribution of less, version iso210, released 12 Jan 97
+    It support ISO 2022 code extension techniques and Japanese codes.
+    Please report any problems of it to the author at jam@poboxes.com.
+    See http://www.io.com/~kazushi/less/ for the latest info.
+=========================================================================
+
+
+**Features**
+ - Support ISO 2022 code extension techniques in 7bits and 8bits.
+ - Understand all escape sequences of ISO 2022 level 3, a special
+   sequence, ESC 2/4[$] 2/12[,] FE, which is used in MULE and Japanese 
+   codes which are UJIS and SJIS.
+ - Support some environment of users.  Output as CTEXT, which is
+   defined in X11, if a user use iso8.  Output only GZDM4, GZD4,
+   G1DM4, G1DM6, G1D4, G1D6, SI and SO escape sequences if a user use
+   iso7.  Output some Japanese codes if a user use it.
+ - Automatic invoking of zcat.
+
+**Problems**
+ - To compare for search, less convert data and a pattern into
+   internal codes.  Thus some codes which has a gap in internal
+   representation is not found by less.  Such codes are Right Half of
+   JIS X0201 Japanese (Katakana) in UJIS, JIS X0212-1990 Japanese
+   Supplement in UJIS and codes which contain escape sequence.
+ - I didn't make any multi bytes code enhancements for regular
+   expression library.  Thus less don't understand regular expression
+   to such multi bytes codes.  If you have an UJIS regular expression
+   library, you may use it with a definition of UJIS_REGEXP to 1.
+
+**Enhancements**
+ - JLESSCHARET environment variable choose codes for input and output.
+   For example, if you set "japanese-iso7", less read all Japanese
+   codes and iso7 and write iso7.  If you set "ujis", less read and
+   write only UJIS.  Currently you can use followings.
+     Same as LESSCHARSET: ascii, latin1, dos, koi8-r, next
+     Others: iso7, iso8, ujis-iso7, euc-iso7, sjis-iso7, jis,
+	     ujis-jis, euc-jis, sjis-jis, ujis, euc, jis-ujis,
+	     jis-euc, sjis, jis-sjis, japanese, japanese-iso7,
+	     japanese-jis, japanese-ujis, japanese-euc, japanese-sjis
+ - Following values of JLESSCHARSET are treated for input and output
+   separately.  For example, if you set "ujis-sjis", less read only
+   UJIS and write only SJIS.
+     Values: ujis-sjis, euc-sjis, sjis-ujis, sjis-euc
+ - JLESSPLANESET environment variable choose plane of iso8 and iso7.
+   Please read a manual about details.
+ - JLESSKEYCHARET environment variable choose codes for input from
+   keyboard.  All values for JLESSCHARSET environment variable are
+   used for this.
+ - Sometime less may mistake automatic handling of Japanese codes.
+   The user change the status for it by '@' key.  The function name
+   of it is "rotate-right".
+
+**History about Japanized and ISO 2022-ized less**
+ - About Japanization of less
+   - Kato-san changed less-123 (maybe) for JIS code.
+   - There are many patches for less.
+   - I changed less-177 for all Japanese codes.
+   - Kusakabe-san changed less-178 by using patches for less-177.
+   - Senda-san add printing function of Japanese code for less-177.
+   - Sakai-san changed less-200 by using patches for less-178.
+   - I changed less-205 for all Japanese codes and ISO 2022 codes.
+   - Ushine-san changed less-321 by using patches for less-290.
+   - I changed less-330 by using patches for less-290.  It is named
+     iso202.
+   - I removed some bugs and made jless-330-iso203.
+   - I re-wrote jless and made jless-330-iso208.
+   - I released patches to correct bugs.
+
+ - About jless
+   - I put 2 unofficial patches of KANJI searching enhancements for
+     ISO 2022-ized less-237 on ftp.
+   - I put an unofficial patch to use gawk-2.15.6-mb1.04's KANJI
+     regular expression library for jless-330-iso210 on ftp.  It will
+     works with iso212 and following.
+   - I put a less.hlp file which is translated into Japanese.  It will 
+     works with iso212 and following.
+
+**FAQ**
+ Q: When I try to view Japanese text, the less show inverse characters
+    only.  How do I view them?
+ A: You have to set "japanese" to JLESSCHARSET environment variable.
+    Otherwise you have to set "ja_JP" to LANG environment variable if
+    your computer support it.
+
+ Q: When I try to view Japanese text, the less show strange characters
+    only like '$' and others.  How do I view them?
+ A: Does your terminal or terminal emulator have ability to show
+    Japanese?  If your terminal has such ability, you have to adjust
+    the Japanese code by setting "japanese-ujis" or "japanese-sjis" to 
+    JLESSCHARSET environment variable.
+
+ Q: When I try to view compressed text, less doesn't work.  How do I
+    view them?
+ A: The less use the name of text file to check that it is compressed
+    and use "zcat" program to uncompress it.  It means that the
+    compressed file has to have ".z", ".gz" or ".Z" as the extension
+    name and the "zcat" has ability to uncompress them.  I think you
+    should install GNU's gzip as "zcat".
+
+ Q: How to set the default value of JLESSCHARSET environment variable.
+ A: You can use DEFCHARSET declaration in "defines.h".  If your
+    computer has a LANG property, you have to set HAVE_LOCALE to 0 in
+    "defines.h".  Note: before editing it, you should execute
+    "configure" program.
+
+ Q: Sometime my terminal shows not ASCII characters only.
+ A: Some terminal emulator has bugs in handling the ISO 2022.  You
+    should tell the less to display only JIS by setting "japanese-jis" 
+    to JLESSCHARSET environment variable.
+
+ Q: Sometime the less shows wrong Japanese when I try to view SJIS
+    code files.
+ A: My automatic Japanese code handling routine has some problem
+    because same value of data become different character in each
+    code.  You should type '^L' to re-view it.  If it doesn't work,
+    you should type '@' to change it to the manually handling routine.
+
+    On the other hand, if you use less with a -Z option, less give
+    priority to SJIS over UJIS in automatic handling routine.  And you
+    can change the default value of priority and invert the means of a
+    -Z option by compiling with SJIS_PRE declaration.
+
+    Or if you know the file is SJIS before executing the less, you
+    should set "sjis" to JLESSCHARSET environment variable to diable
+    the automatic handling routine.
+
+ Q: How do I use SJIS as input string?
+ A: You should set "sjis-jis" to JLESSKEYCHARSET environment
+    variable.  Otherwise you should set "sjis-jis" to DEFKEYCHARSET
+    declaration in "defines.h".
+
+ Q: How do I input search pattern by JIS?
+ A: Normally the less use "\e$" sequence.  You should write following
+    in your "~/.lesskey" file and execute "lesskey" program to cancel
+    it.
+
+#line-edit
+\e$	insert ^V\e$
+
+ Q: How do I use emacs-like key binding?
+ A: You should write following in your "~/.lesskey" file and execute
+    "lesskey" program.
+
+#line-edit
+^A	home
+^E	end
+^P	up
+^N	down
+^F	right
+^B	left
+\ef	word-right
+^D	delete
+\ed	word-delete
+
+ Q: The os.c was not compiled on NEWS-OS 4.0C.
+ A: Add following before "#include <setjmp.h>".
+
+#define LANGUAGE_C   1
+
+**Conclusion**
+ - Current problem is searching of multi byte characters with regular
+   expression.
+ - Please mail to "jam@poboxes.com" if you have problem or suggestion.
+ - At "ftp://ftp.aist-nara.ac.jp/pub/personal/kazusi-m/less", I will
+   keep all patches and contributed patches about jless.  If you make
+   any patches, please mail to me about it.
+
+
+Local Variables:
+mode: indented-text
+fill-column: 70
+End:
Index: less/README.iso.jp
diff -u /dev/null less/README.iso.jp:1.8
--- /dev/null	Sun Mar  9 23:07:13 1997
+++ less/README.iso.jp	Sat Jan 25 07:12:42 1997
@@ -0,0 +1,203 @@
+=========================================================================
+    This is the distribution of less, version iso210, released 12 Jan 97
+    It support ISO 2022 code extension techniques and Japanese codes.
+    Please report any problems of it to the author at jam@poboxes.com.
+    See http://www.io.com/~kazushi/less/ for the latest info.
+=========================================================================
+    This file is written by Japanese and JIS code and contains
+    almost same information in README.iso.
+=========================================================================
+
+
+**$BFCD'(B**
+ - ISO 2022 in 7bits$B$H!"(Bin 8bits$B$r%5%]!<%H!#(B
+ - $BF~NO$H$7$F$O!"(BISO 2022$B$N<BAu%l%Y%k(B3$BAjEv$H!"(BMULE$B$GMxMQ$5$l(B
+   $B$F$$$k(BESC 2/4[$] 2/12[,] FE$B$H$$$&FC<l$J3dEv$H!"(BUJIS$B!"(BSJIS
+   $B$H$$$C$?F|K\8l%3!<%I$r!"2r<a$G$-$k!#(B
+ - $B=PNO$H$7$F$O!"(Biso8$B4D6-$K=PNO$9$k>l9g$O(BX11$B$J$I$G8@$&=j$N(B
+   CTEXT$B$H$7$F=PNO!#(Biso7$B4D6-$KBP$7$F=PNO$9$k>l9g$O(BG0$B!"(BG1$B$X$N(B
+   $B8F$S=P$7%7!<%1%s%9$H(BSI, SO$B$@$1$r;H$C$F=PNO!#(B
+ - compress$B$d(Bgzip$B$5$l$?%U%!%$%k$r4JC1$KD/$a$k$3$H$,$G$-$k!#(B
+
+**$BLdBjE@(B**
+ - $BF|K\8l$d(BISO 2022$B$N8!:w$O!"FbIt%3!<%I$G=hM}$7$^$9!#$=$NJQ(B
+   $B49$N:]$K7d4V$,H/@8$9$k4A;z%3!<%I$K$D$$$F$O!"8!:w$,$G$-$^(B
+   $B$;$s!#$=$&$7$?%3!<%I$O!"(BUJIS$B$GI=8=$5$l$?(BRight Half of JIS
+   X0201 Japanese(Katakana)$B$d(BJIS X0212-1990 Japanese
+   Supplement$B$K$J$j$^$9!#$^$?!"(BJIS$B!"(BISO 2022$B$GMxMQ$5$l$k%(%9(B
+   $B%1!<%W%7!<%1%s%9$r$O$5$s$@J8;zNs$b8!:w$G$-$^$;$s!#(B
+ - $B@55,I=8=%i%$%V%i%j$K$O<j$r2C$($F$$$J$$$N$G!"J8;z<o$N0c$$(B
+   $B$OH=CG$G$-$^$;$s$7!"J#?t%P%$%HJ8;z$N@55,I=8=$X$bBP1~$7$F(B
+   $B$$$^$;$s!#$b$7!"(BUJIS$B$N@55,I=8=%i%$%V%i%j$,MxMQ$G$-$k$J$i!"(B
+   UJIS_REGEXP$B$r(B1$B$KDj5A$9$k$3$H$G!"A0<T$NLdBj$N0lIt$H8e<T$N(B
+   $BLdBj$r2r7h$G$-$k2DG=@-$,$"$j$^$9(B($BKM$O$=$N$h$&$J%i%$%V%i%j(B
+   $B$rMxMQ$G$-$J$$$?$a!"%F%9%H$J$I$O9T$J$C$F$$$^$;$s(B)$B!#(B
+
+**$B3HD%E@(B**
+ - JLESSCHARET$B4D6-JQ?t$G!"F~NO$H=PNO$KMxMQ$9$k%3!<%I$r;XDj$G(B
+   $B$-$^$9!#Nc$($P!"(B"japanese-iso7"$B$H$9$k$H!"F|K\8l$N%3!<%I$9(B
+   $B$Y$F$H(Biso7$B$rF~NO$H$7$F<h$j07$$!"$=$l$r(Biso7$B$G=PNO$7$^$9!#(B
+   $B$^$?!"(B"ujis"$B$H$9$k$H!"(BUJIS$B$@$1$rF~NO$H=PNO$KMxMQ$7$^$9!#(B
+   $B8=:_0J2<$NCM$,MxMQ$G$-$^$9!#(B
+     $B:G=i$+$i$"$C$?$b$N(B: ascii, latin1, dos, koi8-r, next
+     $B3HD%$7$?$b$N(B: iso7, iso8, ujis-iso7, euc-iso7,
+		   sjis-iso7, jis, ujis-jis, euc-jis,
+		   sjis-jis, ujis, euc, jis-ujis, jis-euc,
+		   sjis, jis-sjis, japanese, japanese-iso7,
+		   japanese-jis, japanese-ujis,
+		   japanese-euc, japanese-sjis
+   $B$^$?!"FC<l$J$b$N$H$7$F!"$"$k%3!<%I$rF~NO$7!"$"$k%3!<%I$G(B
+   $B=P$9$H$$$&;XDj$b$"$j$^$9!#Nc$($P!"(B"ujis-sjis"$B$H$9$k$H!"(B
+   UJIS$B$@$1$rF~NO$H$7$F07$$!"$=$l$r(BSJIS$B$KJQ49$7$F=PNO$7$^$9!#(B
+     $BFC<l$J$b$N(B: ujis-sjis, euc-sjis, sjis-ujis, sjis-euc
+
+ - JLESSPLANESET$B4D6-JQ?t$G!"(Biso8$B$d(Biso7$B$N(Bplane$B$r7h$a$k$3$H$,(B
+   $B$G$-$^$9!#>\$7$/$O%^%K%e%"%k$rFI$s$G2<$5$$!#(B
+ - JLESSKEYCHARET$B4D6-JQ?t$G!"%-!<%\!<%I$+$i$NF~NO$KMxMQ$9$k(B
+   $B%3!<%I$r;XDj$G$-$^$9!#(BJLESSCHARSET$B$HF1$8CM$,MxMQ$G$-$^$9!#(B
+ - $B<+F0H=JL$@$1$G$OET9g$,0-$$$3$H$b$"$k$?$a!":G>e0L%S%C%H$,(B
+   $BN)$C$?%3!<%I$NH=JLJ}K!$r=g!9$KJQ99$9$k$?$a$N%-!<$rMQ0U$7(B
+   $B$F$$$^$9!#(B'@'$B%-!<!"5!G=L>$O(B"rotate-right"$B$G$9!#(B
+
+**less$B$NF|K\8l2=$d4XO"$7$?%Q%C%A$NNr;K(B**
+ - less$B$NF|K\8l2=$K4X$7$F(B
+   - less-123($B!)(B)$B$r2CF#$5$s$,(BJIS$B2=$5$l$?!#(B
+   - $B$=$NB>?'!9$J%Q%C%A$,=P$?!#(B
+   - less-177$B$r$+$:$7$,F|K\8l2=$7$?!#(B
+   - less-178$B$K(Bless-177$B$N%Q%C%AB>$r$"$F$?$b$N$r$/$5$+$Y$5$s(B
+     $B$,Ej9F$5$l$?!#(B
+   - less-177$B$K@gED$5$s$,4A;z%3!<%II=<(5!G=$rDI2C$5$l$?!#(B
+   - less-200$B$K(Bless-178$B$N%Q%C%AB>$r$"$F$?$b$N$r<r0f$5$s$,Ej(B
+     $B9F$5$l$?!#(B
+   - less-205$B$r$+$:$7$,(BISO 2022$B2=$H$7$FEj9F$7$?!#(B
+   - less-321$B$K(Bless-290$B$N(BISO 2022$B2=$r$"$F$?$b$N$r5m:,$5$s$,(B
+     $BEj9F$5$l$?!#(B
+   - less-330$B$K2a5n$N(BISO 2022$B2=$r$=$N$^$^N.MQ$7$?(B
+     jless-330-iso202$B$r$+$:$7$,Ej9F$7$?!#(B
+   - $B%P%0$r<h$C$F(Bjless-330-iso203$B$H$7$FEj9F$7$?!#(B
+   - $BBgI}$K=q$-D>$7$F(Bjless-330-iso208$B$H$7$FEj9F$7$?!#(B
+   - $B?'!9$H%P%0$r<h$C$FEj9F!"8x3+$7$?!#(B
+
+ - jless$B$K4X$7$F(B
+   - less-237$B$r(BISO 2022$B2=$7$?$b$N$KBP$9$k4A;z8!:w%Q%C%A(B2$B<o$r(B
+     $B8x3+$7$?!#(B
+   - jless-330-iso210$B$G(Bgawk-2.15.6-mb1.04$B$N4A;z@55,I=8=%i%$(B
+     $B%V%i%j$rMxMQ$9$k$?$a$N%Q%C%A$r8x3+$7$?!#(Biso212$B0J9_$G$b(B
+     $BMxMQ2DG=!#(B
+   - jless-330-iso212$B$N(Bless.hlp$B$rF|K\8l2=$7$?$b$N$r8x3+$7$?!#(B
+     iso212$B0J9_$G$bMxMQ2DG=!#(B
+
+**FAQ**
+ Q: $BF|K\8l$,I=<($5$l$^$;$s!#2hLL>e$O!"H?E>I=<($5$l$?J8;z$G0l(B
+    $BGU$G$9!#(B
+ A: JLESSCHARSET$B4D6-JQ?t$K(B"japanese"$B$H@_Dj$7$^$7$g$&!#(BLANG$B4D(B
+    $B6-JQ?t$K(B"ja_JP"$B$J$I@_Dj$9$k$H$$$&J}K!$b$"$j$^$9!#9%$-$J(B
+    $BJ}K!$rA*$s$G2<$5$$!#(B
+
+ Q: $BF|K\8l$,I=<($5$l$^$;$s!#2hLL>e$O!"$J$s$+5-9f$G0lGU$G$9!#(B
+ A: less$B$,=PNO$7$F$$$k4A;z$rC<Kv$G<h$j07$($F$$$J$$$h$&$G$9!#(B
+    JLESSCHARSET$B4D6-JQ?t$K(B"japanese-ujis"$B$d(B"japanese-sjis"$B$J(B
+    $B$I!"MxMQ$7$F$kC<Kv$GI=<($G$-$k4A;z%3!<%I$r;XDj$7$F2<$5$$!#(B
+
+ Q: $B05=L$5$l$?%U%!%$%k$rFI$`$3$H$,$G$-$^$;$s!#(B
+ A: $B05=L$5$l$?%U%!%$%k$O(B".z"$B$d(B".gz"$B!"(B".Z"$B$H$$$C$?3HD%;R$K$h$C(B
+    $B$F6hJL$5$l$F$^$9!#$^$?!"$=$N%U%!%$%k$rE83+$9$k$K$O!"C1$K(B
+    "zcat"$B$r<B9T$7$F$$$^$9!#(BGNU$B$N(Bgzip$B$r(Bzcat$B$H$$$&L>A0$G%$%s(B
+    $B%9%H!<%k$7$F$*$/$3$H$r$*A&$a$7$^$9!#(B
+
+ Q: $BAG?M$N?M$G$b!"4A;z$,I=<($G$-$k$h$&$K!"%G%#%U%)%k%H$N@_Dj(B
+    $B$r$7$F%$%s%9%H!<%k$7$?$$$N$G$9$,!#(B
+ A: JLESSCHARSET$B$J$I$N4D6-JQ?t$,@_Dj$5$l$F$$$J$$>l9g$O!"(B
+    defines.h$BCf$N(BDEFCHARSET$B%^%/%m$NJ8;zNs$rMxMQ$7$^$9!#$3$l(B
+    $B$NJQ99$K$O!"$^$:(Bconfigure$B$r<B9T$7$F$*$/I,MW$,$"$j$^$9!#(B
+    $B$=$N8e$K!"(BDEFCHARSET$B%^%/%m$K(B"japanese"$B$J$I$NJ8;zNs$r@_Dj(B
+    $B$7!"<!$K(BHAVE_LOCALE$B%^%/%m$r(B0$B$K$7$F!"%3%s%Q%$%k$7$F2<$5$$!#(B
+
+ Q: $B$"$k%U%!%$%k$rFI$`$H!"2hLL$KI=<($5$l$kJ8;z$,2u$l$F$7$^$$!"(B
+    $B85$KLa$j$^$;$s!#(B
+ A: $BC<Kv$K$h$C$F$O(BISO 2022$B$r$A$c$s$H%5%]!<%H$7$F$$$^$;$s!#$=(B
+    $B$&$$$C$?C<Kv$rMxMQ$7$F$$$k>l9g$O!"(BJLESSCHARSET$B4D6-JQ?t$K!"(B
+    "japanese-jis"$B$J$I$H!"(BJIS$B$@$1$rMxMQ$9$k$3$H$rL@3N$K@_Dj(B
+    $B$7$F;H$C$F2<$5$$!#(B
+
+ Q: SJIS$B$N%U%!%$%k$rFI$`$H!"$?$^$KJQ$JJ8;z$,I=<($5$l$^$9!#(B
+ A: $B4A;z$N<+F0H=JL$O40`z$G$O$"$j$^$;$s!#$=$N$?$a!"B?>/LdBj$,(B
+    $BH/@8$7$^$9!#(B'^L'$B$HF~NO$7!"2hLL$r:FIA2h$9$k$HD>$k>l9g$,B?(B
+    $B$$$G$9!#$=$l$G$bBLL\$J$i!"(B'@'$B%-!<$r?t2s2!$7$F!"2hLL2<$K(B
+    "sjis codeset..."$B$HI=<($5$;$F2<$5$$!#<+F0H=JL$r6X;_$G$-(B
+    $B$^$9!#85$N>uBV$KLa$9$K$O!"$3$N%-!<$r7+$jJV$72!$7$F2<$5$$!#(B
+
+    $B0lJ}!"0z?t$K(B-Z$B$H;XDj$9$k$3$H$G!"(BSJIS$B$rM%@h$7$F<+F0H=JL$r(B
+    $B9T$&$3$H$b$G$-$^$9!#%3%s%Q%$%k;~$K(BSJIS_PRE$B$rDj5A$9$l$P!"(B
+    $B:G=i$+$i(BSJIS$B$rM%@h$7!"(B-Z$B$G:#EY$O5U$K(BUJIS$B$rM%@h$9$k$H$$$C(B
+    $B$?!"5U$NF0:n$r$9$k$h$&$K$b$G$-$^$9!#(B
+
+    $B$^$?!"(BJLESSCHARSET$B4D6-JQ?t$r(B"sjis"$B$K$9$k$3$H$G!":G=i$+$i(B
+    $B<+F0H=JL$r6X;_$9$k$3$H$b$G$-$^$9!#(B
+
+    $B$D$$$G$G$9$N$G!"<+F0H=JL$K$D$$$F!"$A$g$C$H@bL@$7$F$*$-$^(B
+    $B$9!#$^$:!"(Bless$B$G$O!"%P%C%U%!%j%s%0L5$7$GH=JL$r?J$a$k$?$a!"(B
+    $B4V0c$$$,B?$$$G$9!#$7$+$7!"0l2hLLJ,H=JL$7$?8e$K$OH=JL$,>e(B
+    $B<j$/$$$C$F$$$k$H9M$($i$l$k$?$a!"$=$l$G:Q$^$7$F$$$^$9!#(B
+
+    $BH=JLJ}K!<+BN$O!"IaDL$NJ}K!$G$9!#(BSJIS$B$H(BUJIS$B$H$G=E$J$C$F$$(B
+    $B$k%3!<%I$K$D$$$F$O!"H=JL8e$K8mH=JL$7$F$$$J$$$+$I$&$+D4::(B
+    $B$9$k$3$H$K$h$C$F!"H=JL$N<:GTN($r2<$2$F$$$k$D$b$j$G$9!#6q(B
+    $BBNE*$K$O!"(BSJIS$B$G8=$o$5$l$?(BJIS X0201 Japanese(Katakana)$B$H(B
+    $BH=CG$7$?Ns$NCf$K!"(B0xa4$B$,(B1$BJ8;z$*$-$K=P$F$-$?>l9g!"(BUJIS$B$N(B
+    $BJ?2>L>$NNs$G$"$k$H$7$F!"H=JL7k2L$rJQ99$7$F$$$^$9!#5U$r8@(B
+    $B$&$H!"(BSJIS$B$G8=$o$7$?(BJIS X0201 Japanese(Katakana)$B$NNs$NCf(B
+    $B$K!V(I$$B!W$r(B3$B2sB3$1$F(B1$BJ8;z$*$-$KF~$l$k$H!"8mH=JL$,H/@8$9$k(B
+    $B2DG=@-$,9b$/$J$j$^$9!#(B
+
+ Q: SJIS$B$G8!:w$9$kF|K\8l$rF~$l$k$HJQ$K$J$j$^$9!#(B
+ A: JLESSKEYCHARSET$B4D6-JQ?t$K(B"sjis-jis"$B$H@_Dj$7$^$7$g$&!#$^(B
+    $B$?%3%s%Q%$%k$9$k:]$K!"(Bdefines.h$BCf$G!"(BDEFKEYCHARSET$B$KDj5A(B
+    $B$7$F$$$kJ8;zNs$r!"(B"sjis-jis"$B$KJQ49$9$k$H$$$&<j$b$"$j$^$9!#(B
+
+ Q: $B8!:w$N;~$K4A;z$r(BJIS$B$GF~NO$7$h$&$H;W$&$N$G$9$,!">e<j$/$G(B
+    $B$-$^$;$s!#(B
+ A: $B%G%#%U%)%k%H$N@_Dj$G$O!"(B\e$$B$H$$$&%-!<F~NO$,MxMQ$5$l$F$$(B
+    $B$^$9!#(B"~/.lesskey"$B%U%!%$%k$K0J2<$r=q$-!"(Blesskey$B$r<B9T$7(B
+    $B$F$*$/$3$H$K$h$j!"(BJIS$B$GF~NO$G$-$k$h$&$K$J$j$^$9!#(B
+
+#line-edit
+\e$	insert ^V\e$
+
+ Q: $B:G2<9T$G$NJT=8$r(Bemacs-like$B$K$d$j$?$$$G$9!#(B
+ A: "~/.lesskey"$B%U%!%$%k$K0J2<$r=q$-!"(Blesskey$B$r<B9T$7$F2<$5(B
+    $B$$!#(B
+
+#line-edit
+^A	home
+^E	end
+^P	up
+^N	down
+^F	right
+^B	left
+\ef	word-right
+^D	delete
+\ed	word-delete
+
+ Q: NEWS-OS 4.0C$B$G$O!"(Bos.c$B$,%3%s%Q%$%k$G$-$^$;$s!#(B
+ A: "#include <setjmp.h>"$B$NA0$K!"0J2<$NDj5A$rF~$l$F2<$5$$!#(B
+
+#define LANGUAGE_C   1
+
+**$B:G8e$K(B**
+ - $B;D$k2]Bj$O!"J#?t%P%$%H$N8!:w$G$9!#$7$+$7!"$3$l$r=$@5$9$k(B
+   $B$K$O!"@55,I=8=%i%$%V%i%j$H??LLL\$K8~$-$"$&I,MW$,$"$j$^$9!#(B
+   $B:#$N=j!"$=$NM=Dj$O$"$j$^$;$s!#%Q%C%A$J$I!"4?7^$7$^$9!#(B
+ - $BLdBj$d2~A1MW5a$,$"$l$P(Bjam@poboxes.com$B$K%a%$%k$7$F2<$5$$!#(B
+   $BBP=h$G$-$k$+$b$7$l$^$;$s!#$^$?!"2~A1MW5a$K$D$$$F$O!"B??t(B
+   $B=8$^$l$P!"BP=h$9$k2DG=@-$b9b$/$J$j$^$9!#(B
+ - ftp://ftp.aist-nara.ac.jp/pub/personal/kazusi-m/less$B$K%Q%C(B
+   $B%AN`$r$^$H$a$h$&$H;W$C$F$$$^$9$N$G!"2?$+(Bunofficial patch
+   $B$H$7$FEj9F(B/$B%j%j!<%9$7$h$&$H;W$C$?J}$O!"KM$^$G%a%$%k$7$F$b(B
+   $B$i$($k$H4r$7$$$G$9!#(B
+
+
+Local Variables:
+mode: indented-text
+fill-column: 60
+End:
Index: less/charset.c
diff -u less/charset.c:1.1.1.9 less/charset.c:1.49
--- less/charset.c:1.1.1.9	Sun Dec  1 05:40:45 1996
+++ less/charset.c	Sun Jan 12 18:15:23 1997
@@ -2,6 +2,9 @@
  * Copyright (c) 1984,1985,1989,1994,1995,1996  Mark Nudelman
  * All rights reserved.
  *
+ * Copyright (c) 1997  Kazushi (Jam) Marukawa
+ * All rights of japanized routines reserved.
+ *
  * Redistribution and use in source and binary forms, with or without
  * modification, are permitted provided that the following conditions
  * are met:
@@ -38,20 +41,139 @@
 
 /*
  * Predefined character sets,
- * selected by the LESSCHARSET environment variable.
+ * selected by the JLESSCHARSET or LESSCHARSET environment variable.
  */
 struct charset {
 	char *name;
 	char *desc;
+	CODESET left;
+	CODESET right;
+	CODESET output;
 } charsets[] = {
-	{ "ascii",	"8bcccbcc18b95.b"		},
-	{ "latin1",	"8bcccbcc18b95.33b."		},
-	{ "dos",	"8bcccbcc12bc5b95.b."		},
-	{ "koi8-r",	"8bcccbcc18b95.b128."		},
-	{ "next",	"8bcccbcc18b95.bb125.bb"	},
+	{ "ascii",	"8bcccbcc18b95.b",
+		noconv,		none,		noconv		},
+	{ "latin1",	"8bcccbcc18b95.33b.",
+		noconv,		noconv,		noconv		},
+	{ "dos",	"8bcccbcc12bc5b95.b.",
+		noconv,		noconv,		noconv		},
+	{ "koi8-r",	"8bcccbcc18b95.b128.",
+		noconv,		noconv,		noconv		},
+	{ "next",	"8bcccbcc18b95.bb125.bb",
+		noconv,		noconv,		noconv		},
+#if ISO
+	{ "iso7",	"8bcccb4c11bc4b96.b",
+		iso7,		noconv,		iso7		},
+	{ "iso8",	"8bcccb4c11bc4b95.15b2.16b.",
+		iso7,		iso8,		iso8		},
+# if JAPANESE
+	/* read some of KANJI code sets and iso7, write iso7. */
+	{ "ujis-iso7",	"8bcccb4c11bc4b96.14b2.17b94.b",
+		iso7,		ujis,		iso7		},
+	{ "euc-iso7",	"8bcccb4c11bc4b96.14b2.17b94.b",
+		iso7,		ujis,		iso7		},
+	{ "sjis-iso7",	"8bcccb4c11bc4b221.b",
+		iso7,		sjis,		iso7		},
+	/* read some of KANJI code sets, write jis. */
+	{ "jis",	"8bcccb4c11bc4b95.b",
+		jis,		none,		jis		},
+	{ "ujis-jis",	"8bcccb4c11bc4b95.15b2.17b94.b",
+		jis,		ujis,		jis		},
+	{ "euc-jis",	"8bcccb4c11bc4b95.15b2.17b94.b",
+		jis,		ujis,		jis		},
+	{ "sjis-jis",	"8bcccb4c11bc4b95.b125.3b",
+		jis,		sjis,		jis		},
+	/* read some of KANJI code sets, write ujis. */
+	{ "ujis",	"8bcccbcc18b95.15b2.17b94.b",
+		noconv,		ujis,		ujis		},
+	{ "euc",	"8bcccbcc18b95.15b2.17b94.b",
+		noconv,		ujis,		ujis		},
+	{ "jis-ujis",	"8bcccb4c11bc4b95.15b2.17b94.b",
+		jis,		ujis,		ujis		},
+	{ "jis-euc",	"8bcccb4c11bc4b95.15b2.17b94.b",
+		jis,		ujis,		ujis		},
+	/* read some of KANJI code sets, write sjis. */
+	{ "sjis",	"8bcccbcc18b95.b125.3b",
+		noconv,		sjis,		sjis		},
+	{ "jis-sjis",	"8bcccb4c11bc4b95.b125.3b",
+		jis,		sjis,		sjis		},
+	/* read all KANJI code sets, write iso7. */
+	{ "japanese-iso7",	"8bcccb4c11bc4b95.b127.b",
+		iso7,		japanese,	iso7		},
+	/* read all KANJI code sets, write some of KANJI code set. */
+	{ "japanese",		"8bcccb4c11bc4b95.b127.b",
+		jis,		japanese,	jis		},
+	{ "japanese-jis",	"8bcccb4c11bc4b95.b127.b",
+		jis,		japanese,	jis		},
+	{ "japanese-ujis",	"8bcccb4c11bc4b95.b127.b",
+		jis,		japanese,	ujis		},
+	{ "japanese-euc", 	"8bcccb4c11bc4b95.b127.b",
+		jis,		japanese,	ujis		},
+	{ "japanese-sjis",	"8bcccb4c11bc4b95.b127.b",
+		jis,		japanese,	sjis		},
+	/* following entries are special. */
+	/* read ujis, write sjis */
+	{ "ujis-sjis",	"8bcccbcc18b95.15b.18b94.b",
+		noconv,		ujis,		sjis		},
+	{ "euc-sjis",	"8bcccbcc18b95.15b.18b94.b",
+		noconv,		ujis,		sjis		},
+	/* read sjis, write ujis */
+	{ "sjis-ujis",	"8bcccbcc18b95.b125.3b",
+		noconv,		sjis,		ujis		},
+	{ "sjis-euc",	"8bcccbcc18b95.b125.3b",
+		noconv,		sjis,		ujis		},
+# endif
+#endif
 	{ NULL }
 };
 
+#if HAVE_LOCALE && ISO
+/*
+ * Predefined local languages,
+ * selected by the setlocale().
+ */
+struct charlocale {
+	char *name;
+	char *charset;
+} charlocales[] = {
+	{ "C",			"ascii"	},
+	{ "wr_WR.ct",		"iso8"	},
+	{ "ja_JP.jis8",		"iso8"		},
+# if JAPANESE
+	{ "ja_JP.JIS",		"japanese-jis"	},
+	{ "ja_JP.jis7",		"japanese-jis"	},
+	{ "ja_JP.EUC",		"japanese-ujis"	},
+	{ "ja_JP.ujis",		"japanese-ujis"	},
+	{ "ja_JP.SJIS",		"japanese-sjis"	},
+	{ "ja_JP.mscode",	"japanese-sjis"	},
+/* Other local locales */
+#  ifdef _AIX
+	/* AIX's */
+	{ "Ja_JP",		"japanese-sjis" },
+	{ "ja_JP.IBM-eucJP",	"japanese-ujis" },
+	{ "Ja_JP.IBM-932",	"japanese-sjis" },
+#  endif
+#  ifdef __hpux
+	/* HPUX */
+	{ "japanese",		"japanese-sjis" },
+	{ "japanese.euc",	"japanese-ujis" },
+#  endif
+	{ "ja",			"japanese-ujis" },
+	{ "ja_JP",		"japanese-ujis" },
+	{ "japan",		"japanese-ujis"	},
+	{ "Japan",		"japanese-ujis"	},
+	{ "japanese",		"japanese-ujis"	},
+	{ "Japanese",		"japanese-ujis"	},
+	/* DEC OSF/1's */
+	{ "ja_JP.eucJP",	"japanese-ujis"	},
+	{ "ja_JP.deckanji",	"japanese-ujis"	},
+	{ "ja_JP.sdeckanji",	"japanese-ujis"	},
+	/* BSDI's */
+	{ "Japanese-EUC",	"japanese-ujis"	},
+# endif
+	{ NULL }
+};
+#endif
+
 #define	IS_BINARY_CHAR	01
 #define	IS_CONTROL_CHAR	02
 
@@ -61,6 +183,36 @@
 
 
 /*
+ * Return the CODESET of left plane of named charset.
+ */
+	public CODESET
+left_codeset_of_charset(name)
+	register char *name;
+{
+	register struct charset *p;
+
+	for (p = charsets;  p->name != NULL;  p++)
+		if (name && strcmp(name, p->name) == 0)
+			return (p->left);
+	return (noconv);
+}
+
+/*
+ * Return the CODESET of right plane of named charset.
+ */
+	public CODESET
+right_codeset_of_charset(name)
+	register char *name;
+{
+	register struct charset *p;
+
+	for (p = charsets;  p->name != NULL;  p++)
+		if (name && strcmp(name, p->name) == 0)
+			return (p->right);
+	return (none);
+}
+
+/*
  * Define a charset, given a description string.
  * The string consists of 256 letters,
  * one for each character in the charset.
@@ -145,6 +297,9 @@
 		if (strcmp(name, p->name) == 0)
 		{
 			ichardef(p->desc);
+#if ISO
+			init_multi(p->left, p->right, p->output);
+#endif
 			return (1);
 		}
 	}
@@ -162,6 +317,41 @@
 ilocale()
 {
 	register int c;
+#if ISO
+	/*
+	 * We cannot trust in a system's ctype because it
+	 * cannot treat any coding system are not like EUC.
+	 */
+	register char *name;
+	register struct charlocale *p;
+
+#if UJIS_REGEXP
+	/* HP-UX is used LC_COLLATE to specify codes in the regexp library. */
+	(void) setlocale(LC_COLLATE, "");
+#endif
+	name = setlocale(LC_CTYPE, "");
+#ifdef __hpux
+	if (name != NULL)
+		name = getlocale(LOCALE_STATUS)->LC_CTYPE_D;
+#endif
+	/*
+	 * Search some environment variable like a setlocale()
+	 * because some poor system's setlocale treat only
+	 * system's local locale.
+	 */
+	if (name == NULL)
+		name = getenv("LC_CTYPE");
+	if (name == NULL)
+		name = getenv("LANG");
+	for (p = charlocales; name && p->name != NULL; p++)
+	{
+		if (strcmp(name, p->name) == 0)
+		{
+			(void) icharset(p->charset);
+			return;
+		}
+	}
+#endif
 
 	setlocale(LC_ALL, "");
 	for (c = 0;  c < sizeof(chardef);  c++)
@@ -214,6 +404,21 @@
 	s = lgetenv("LESSBINFMT");
 	setbinfmt(s);
 	
+#if ISO
+	s = getenv("JLESSPLANESET");
+	if (s == NULL)
+		s = DEFPLANESET;
+	set_planeset(s);
+#endif
+
+#if ISO
+	/*
+	 * See if environment variable JLESSCHARSET is defined.
+	 */
+	s = lgetenv("JLESSCHARSET");
+	if (icharset(s))
+		return;
+#endif
 	/*
 	 * See if environment variable LESSCHARSET is defined.
 	 */
@@ -221,7 +426,7 @@
 	if (icharset(s))
 		return;
 	/*
-	 * LESSCHARSET is not defined: try LESSCHARDEF.
+	 * JLESSCHARSET and LESSCHARSET are not defined: try LESSCHARDEF.
 	 */
 	s = lgetenv("LESSCHARDEF");
 	if (s != NULL && *s != '\0')
@@ -236,9 +441,10 @@
 	ilocale();
 #else
 	/*
-	 * Default to "ascii".
+	 * All variables are not defined either, default to DEFCHARSET.
+	 * DEFCHARSET is defined in defines.h.
 	 */
-	(void) icharset("ascii");
+	(void) icharset(DEFCHARSET);
 #endif
 }
 
@@ -264,18 +470,38 @@
 	return (chardef[c] & IS_CONTROL_CHAR);
 }
 
+#if ISO
+/*
+ * Change a database to check "control" character.
+ *  This function is called by multi.c only to support iso2022 charset.
+ */
+	public void
+change_control_char(c, flag)
+	int c, flag;
+{
+	c &= 0377;
+	if (flag)
+		chardef[c] |= IS_CONTROL_CHAR;
+	else
+		chardef[c] &= ~IS_CONTROL_CHAR;
+}
+#endif
+
 /*
  * Return the printable form of a character.
  * For example, in the "ascii" charset '\3' is printed as "^C".
  */
 	public char *
-prchar(c)
+prchar(c, cs)
 	int c;
+	CHARSET cs;
 {
 	static char buf[8];
 
 	c &= 0377;
-	if (!control_char(c))
+	if (CSISWRONG(cs) && c > 127)
+		sprintf(buf, binfmt, c);
+	else if (!control_char(c))
 		sprintf(buf, "%c", c);
 	else if (c == ESC)
 		sprintf(buf, "ESC");
Index: less/cmd.h
diff -u less/cmd.h:1.1.1.7 less/cmd.h:1.10
--- less/cmd.h:1.1.1.7	Sat Sep 14 00:36:04 1996
+++ less/cmd.h	Sun Jan 12 18:15:24 1997
@@ -2,6 +2,9 @@
  * Copyright (c) 1984,1985,1989,1994,1995,1996  Mark Nudelman
  * All rights reserved.
  *
+ * Copyright (c) 1997  Kazushi (Jam) Marukawa
+ * All rights of japanized routines reserved.
+ *
  * Redistribution and use in source and binary forms, with or without
  * modification, are permitted provided that the following conditions
  * are met:
@@ -78,6 +81,10 @@
 #define	A_OPT_UNSET		49
 #define	A_F_FOREVER		50
 #define	A_GOPOS			51
+
+#if JAPANESE
+#define A_ROT_RCODESET		80
+#endif
 
 #define	A_INVALID		100
 #define	A_NOACTION		101
